/*==========================================================================*/
/* Vampire3D - Alain THELLIER -  2017 - Paris - FRANCE						*/

/*==========================================================================*/
#define ILOOP(nbre) for(i=0;i<nbre;i++)
#define JLOOP(nbre) for(j=0;j<nbre;j++)
#define MLOOP(nbre) for(m=0;m<nbre;m++)
#define NLOOP(nbre) for(n=0;n<nbre;n++)
#define NLOOP2(nbre) for(n=0;n<nbre;n=n+2)
#define NLOOP4(nbre) for(n=0;n<nbre;n=n+4)
#define NLOOP8(nbre) for(n=0;n<nbre;n=n+8)
#define NLOOP16(nbre) for(n=0;n<nbre;n=n+16)
#define XLOOP(nbre) for(x=0;x<nbre;x++)
#define YLOOP(nbre) for(y=0;y<nbre;y++)
#define ZLOOP(nbre) for(z=0;z<nbre;z++)
#define COPYRGBA(x,y)	*((ULONG *)(x))=*((ULONG *)(y));
#define SWAP(x,y) {temp=x;x=y;y=temp;} 
#define DODEBUG	1
/*==========================================================================*/
#define MAXHEIGHT  2048
/*==================================================================================*/
union Rgba3D {
struct Rgba3DL{
	ULONG RGBA32;
	}  L;
struct Rgba3DB{
	UBYTE RGBA[4];
	}  B;
};
/*==================================================================================*/
union Rgba3DX2 {
struct Rgba3DX2L{
	ULONG RGBA320,RGBA321;
	}  L;
struct Rgba3DX2D{
	double RGBA64;
	}  D;
};
/*==========================================================================*/
struct FixPoint3D{
	LONG x,y,z;	/* Stored as fixed-size (value << 16). Serve also as edge */
	LONG u,v,w;		
	LONG r,g,b,a;
	LONG padding[6];		
};
/*==========================================================================*/
struct Context3D {
struct FixPoint3D edge1[MAXHEIGHT];	
struct FixPoint3D edge2[MAXHEIGHT];
struct FixPoint3D PolyFP[30];
struct RastPort rastport;
struct Screen  *Wscreen;
					/* to directly write to bm */
ULONG InXYZ,OutXYZ;
LONG xmin,ymin,zmin,umin,vmin;
LONG xmax,ymax,zmax,umax,vmax;
UBYTE out[6];
ULONG PolyY,PolyHigh;
	
 LONG *zbuffer;	
ULONG *pixels;	
UWORD w,h,bpp,pad;
struct Texture3D *T;	
	
ULONG Flags;
ULONG DisplayID;
struct Point3D *P;
ULONG *PI;
ULONG PInb;
ULONG TRInb;
struct Window  *window;
};	
struct Context3D* GlobalC;
/*==================================================================*/
#define FCUT(val)    P->val= floor( A->val + ratio*(B->val - A->val) );
#define FRATIO(val)  ratio=(limit - A->val) / (B->val - A->val); P->val=limit;

#define CUT(val)    P->val= A->val + (ratio*((B->val - A->val)>>16) );
#define RATIO(val)  ratio=(limit - A->val) / ((B->val - A->val)>>16); P->val=limit;

#define OR   |
#define AND  &
/*==================================================================*/
inline void PrintFP(struct FixPoint3D *FP)
{
#ifdef DODEBUG	
	if(debug)	printf("P XYZ %ld %ld  %ld UVW %ld %ld %ld \n",FP->x>>16,FP->y>>16,FP->z>>16,FP->u>>16,FP->v>>16,FP->w);
#endif
	;	
}
/*==================================================================*/
inline void PrintP(struct Point3D *P)
{
float f=1000.0;
#ifdef DODEBUG	
//	if(debug)	printf("P XYZ %2.2f %2.2f  %2.2f UVW %2.2f %2.2f %2.2f \n",P->x,P->y,P->z,P->u,P->v,P->w);
	if(debug)	printf("P XYZ %ld %ld %ld UVW %ld %ld %ld \n",(LONG)(P->x*f),(LONG)(P->y*f),(LONG)(P->z*f),(LONG)(P->u*f),(LONG)(P->v*f),(LONG)(P->w*f));
#endif
	;	
}
/*==================================================================*/
inline void CopyFP(struct FixPoint3D *A,struct FixPoint3D *B)
{
	A->x=B->x;
	A->y=B->y;
	A->z=B->z;
	
	A->u=B->u;
	A->v=B->v;
	A->w=B->w;
	
	A->r=B->r;
	A->g=B->g;
	A->b=B->b;
	A->a=B->a;
}
/*==================================================================*/
inline void ClipX(struct FixPoint3D *P,struct FixPoint3D *A,struct FixPoint3D *B,LONG limit)
{
register LONG ratio;

	RATIO(x)
 	CUT(y)
 	CUT(z)
	
	CUT(u)
	CUT(v)
	CUT(w)
	
	CUT(r)
	CUT(g)
	CUT(b)
	CUT(a)	
}
/*==================================================================*/
inline void ClipY(struct FixPoint3D *P,struct FixPoint3D *A,struct FixPoint3D *B,LONG limit)
{
register LONG ratio;

	RATIO(y)
	CUT(x)
	CUT(z)
	
	CUT(u)
	CUT(v)
	CUT(w)
	
	CUT(r)
	CUT(g)
	CUT(b)
	CUT(a)	
}
/*==================================================================*/
inline void ClipZ(struct FixPoint3D *P,struct FixPoint3D *A,struct FixPoint3D *B,LONG limit)
{
register LONG ratio;

	RATIO(z)
	CUT(x)
	CUT(y)

	CUT(u)
	CUT(v)
	CUT(w)
	
	CUT(r)
	CUT(g)
	CUT(b)
	CUT(a)	
}
/*==================================================================*/
ULONG ClipPoly(struct Context3D *Ctx,ULONG Pnb)
{
register struct FixPoint3D *P;
register struct FixPoint3D *PN;
register LONG limit;
register LONG n,NewPnb;
struct FixPoint3D T1[30];
struct FixPoint3D T2[30];


	FUNC
	NewPnb=0;


	NLOOP((Pnb+1))
		{
		CopyFP(&T1[n] , &Ctx->PolyFP[n] );
		}

	P =T1;
	PN=T2;

/*------------------------------------------------*/
	if( Ctx->out[0] != 0 )
	{
	limit=Ctx->xmin;
	NewPnb=0;
	REM(Clip OUTXMIN)

	NLOOP(Pnb)
	{
	if(limit < P[n].x)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit < P[n+1].x))
			{ClipX(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit < P[n+1].x)
			{ClipX(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}
/*------------------------------------------------*/
	if( Ctx->out[1] != 0 )
	{
	limit=Ctx->xmax;
	NewPnb=0;
	REM(Clip OUTXMAX)

	NLOOP(Pnb)
	{
	if(limit > P[n].x)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit > P[n+1].x))
			{ClipX(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit > P[n+1].x)
			{ClipX(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}

	/*------------------------------------------------*/
	if( Ctx->out[2] != 0 )
	{
	limit=Ctx->ymin;
	NewPnb=0;
	REM(Clip OUTYMIN)

	NLOOP(Pnb)
	{
	if(limit < P[n].y)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit < P[n+1].y))
			{ClipY(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit < P[n+1].y)
			{ClipY(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}
/*------------------------------------------------*/
	if( Ctx->out[3] != 0 )
	{
	limit=Ctx->ymax;
	NewPnb=0;
	REM(Clip OUTYMAX)

	NLOOP(Pnb)
	{
	if(limit > P[n].y)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit > P[n+1].y))
			{ClipY(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit > P[n+1].y)
			{ClipY(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}
/*------------------------------------------------*/
	if( Ctx->out[4] != 0 )
	{
	limit=Ctx->zmin;
	NewPnb=0;
	REM(Clip OUTZMIN)

	NLOOP(Pnb)
	{
	if(limit < P[n].z)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit < P[n+1].z))
			{ClipZ(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit < P[n+1].z)
			{ClipZ(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}
/*------------------------------------------------*/
	if( Ctx->out[5] != 0 )
	{
	limit=Ctx->zmax;
	NewPnb=0;
	REM(Clip OUTZMAX)

	NLOOP(Pnb)
	{
	if(limit > P[n].z)
		{
		CopyFP(&PN[NewPnb++],&P[n]);
		if(!(limit > P[n+1].z))
			{ClipZ(&PN[NewPnb++],&P[n],&P[n+1],limit); }
		}
	else
		{
		if(limit > P[n+1].z)
			{ClipZ(&PN[NewPnb++],&P[n+1],&P[n],limit); }

		}
	}
	CopyFP(&PN[NewPnb],&PN[0]);
	Pnb=NewPnb;

	if(P==T1) {P=T2;PN=T1;} else {P=T1;PN=T2;}
	}
/*------------------------------------------------*/
	if(Pnb<3) return(0);

REM(new points)
	NLOOP((Pnb+1))
			{
			CopyFP(&Ctx->PolyFP[n],&P[n]);
			PrintFP( &Ctx->PolyFP[n] );
			}
	return(Pnb);
}
/*==================================================================*/
ULONG TestPoly(struct Context3D *Ctx,ULONG Pnb)
{
register struct FixPoint3D *P=Ctx->PolyFP;
register ULONG n;

	FUNC
	NLOOP(Pnb)
		PrintFP( &Ctx->PolyFP[n] );

	Ctx->out[0]=Ctx->out[1]=Ctx->out[2]=Ctx->out[3]=Ctx->out[4]=Ctx->out[5]=0;

	NLOOP(Pnb)
	{
	if(P[n].x < Ctx->xmin) Ctx->out[0]++;
	if(P[n].x > Ctx->xmax) Ctx->out[1]++;
		
	if(P[n].y < Ctx->ymin) Ctx->out[2]++;
	if(P[n].y > Ctx->ymax) Ctx->out[3]++;
		
	if(P[n].z < Ctx->zmin) Ctx->out[4]++;
	if(P[n].z > Ctx->zmax) Ctx->out[5]++;
	}

	if(Ctx->out[0]==Pnb)				/* all outside screeen */
		return(-1);
	if(Ctx->out[1]==Pnb)		
		return(-1);
	if(Ctx->out[2]==Pnb)		
		return(-1);
	if(Ctx->out[3]==Pnb)		
		return(-1);
	if(Ctx->out[4]==Pnb)		
		return(-1);
	if(Ctx->out[5]==Pnb)	
		return(-1);

	n=Ctx->out[0]+Ctx->out[1]+Ctx->out[2]+Ctx->out[3]+Ctx->out[4]+Ctx->out[5];
	if(n==0)			/* none outside screeen : all inside screeen : ok */
		return(1);

	return(0);
}
/*==================================================================*/
#define ASRGBA64(ptr) (*((double*)ptr))
#define ASRGBA32(ptr) (*(( ULONG*)ptr))
#define ASRGB16(ptr)  (*(( UWORD*)ptr))

#define MUL8(src,dst,c,sa,da)	dst[c]=( ((ULONG) ( ((UWORD)src[c])*sa + ((UWORD)dst[c])*da ))>>8)
#define MULCOL(c,sa,da)	MUL8(T0.B.RGBA,D0.B.RGBA,c,sa,da)
#define MULRGB(sa,da) 	if(sa==255) {D0.L.RGBA32=T0.L.RGBA32;} else { MULCOL(0,sa,da); MULCOL(1,sa,da); MULCOL(2,sa,da);	}

#define MOD8(src,dst,c)	dst[c]=( ((ULONG) ( ((UWORD)src[c])*((UWORD)dst[c])  ))>>8)
#define MODCOL(c)			MOD8(C0.B.RGBA,T0.B.RGBA,c)
#define MODRGBA   { MODCOL(0); MODCOL(1); MODCOL(2); MODCOL(3);	}
/*==================================================================*/
void FillPoly(struct Context3D *Ctx,struct FixPoint3D *Edge1,struct FixPoint3D *Edge2)
{
register LONG x,dx;
register LONG z,dz;
	
register LONG u,du;
register LONG v,dv;
register LONG w,dw;
	
register LONG r,dr;
register LONG g,dg;
register LONG b,db;
register LONG a,da;
	
register ULONG m,n;
register LONG y;

register ULONG *Tex32;		
register ULONG *Dst32;			
register ULONG *Dst32X;		
register LONG *Zbuf32;			
register LONG *Zbuf32X;			
register ULONG sline;
register ULONG dline;
register union Rgba3D T0;		/* texel */
register union Rgba3D D0;		/* destination pixel from screen */
register union Rgba3D C0;		/* current gouraud */

//..............|..................................
// .............|..#@..............................
// ..Out........|.#..@..........Clipped Triangle...
// ..of screen..|#....@.........to fill............
// .............x#.....@........between edges......
// ............x.#......@..........................
// ...........x..#.......@.........................
// ..........x...#........@........................
// .........x....#.Edge1...@.Edge2.................
// ..........x...#..........@...........In Screen..
// ............ x#...........@.....................
// .............|.#...........@....................
// .............|....#.........@...................
// .........Clip|......#........@..................
// -------------|---------x------x-------Clip------
// .............|............x....x................
// .............|...............x..x...Out.........
// .............|..................xx..of screen...
//..............|..................................

#define SRC_A (T0.B.RGBA[3])
	
	FUNC
	y=Ctx->PolyY;	
	Edge1=&Edge1[y];
	Edge2=&Edge2[y];

/*  Init Texture & Screen pointers  */	
	Tex32=(ULONG*)Ctx->T->pixels;
	sline=Ctx->T->w;
	
	Dst32=(ULONG*)Ctx->pixels;
	dline=Ctx->w;

	Zbuf32=(LONG*)Ctx->zbuffer;

/* for poly height fill each horizontal segments */	
	MLOOP(Ctx->PolyHigh)
	{
	x =(Edge1->x);					/* first-pixel x */
	dx=(Edge2->x - Edge1->x)+1;		/* horizontal segment size in pixels */

	if(dx < 1)
		goto LineDone;

/* get first-pixel value for each "channels" */	
	z=(Edge1->z);	
	
	u=(Edge1->u);		
	v=(Edge1->v);		
	w=(Edge1->w);
	
	r=(Edge1->r);	
	g=(Edge1->g);	
	b=(Edge1->b);	
	a=(Edge1->a);	

/* compute linear distance (delta) for each "channels" among x */	
	dz=(((Edge2->z>>16) - (Edge1->z>>16))<<16)/dx;	
	
	du=(((Edge2->u>>16) - (Edge1->u>>16))<<16)/dx;	
	dv=(((Edge2->v>>16) - (Edge1->v>>16))<<16)/dx;	
	dw=(((Edge2->w>>16) - (Edge1->w>>16))<<16)/dx;	

	dr=(((Edge2->r>>16) - (Edge1->r>>16))<<16)/dx;	
	dg=(((Edge2->g>>16) - (Edge1->g>>16))<<16)/dx;	
	db=(((Edge2->b>>16) - (Edge1->b>>16))<<16)/dx;	
	da=(((Edge2->a>>16) - (Edge1->a>>16))<<16)/dx;	
	
	Dst32X =&Dst32 [y*dline + x];		/* Pointer on the start of the segment on screen */
	Zbuf32X=&Zbuf32[y*dline + x];		/* Pointer on the start of the segment on zbuffer*/

/* fill an horizontal segment */	
	NLOOP(dx)
		{
			if(z < Zbuf32X[n])		/* do a W3D_Z_LESS test */
			{	
			Zbuf32X[n]=z;
			T0.L.RGBA32=Tex32[ (v>>16)*sline + (u>>16)];						/* get texel */

			if(C.UseGouraud)
				{	
				C0.L.RGBA32=((r>>16)<<24)+((g>>16)<<16)+((b>>16)<<8)+((a>>16));		/* get current gouraud color as RGBA32*/
				MODRGBA																/* modulate effect for Texture/Color */
				}
			
			if(SRC_A)		/* if texel alpha (else is invisible for alpha==0) */
				{
				D0.L.RGBA32=Dst32X[n];
				MULRGB(SRC_A,(255-SRC_A));		/* do alpha transparency for Texture/Screen */
				Dst32X[n]=D0.L.RGBA32;
				}
			}	

/* next pixel: new values for each "channels" */	
		z=z+dz;
			
		u=u+du;	
		v=v+dv;
		w=w+dw;
			
		r=r+dr;
		g=g+dg;
		b=b+db;
		a=a+da;
		}
		
LineDone:		
	Edge1++;		/* next line of poly */	
	Edge2++;
	y++;	
	}

}
/*==================================================================*/
void DrawEdge(struct Context3D *Ctx,struct FixPoint3D *P0,struct FixPoint3D *P1)
{
register struct FixPoint3D *E;
register LONG x,dx;
register LONG y,dy; 
register LONG z,dz; 
register LONG u,du;
register LONG v,dv;
register LONG w,dw;
register LONG r,dr;
register LONG g,dg;
register LONG b,db;
register LONG a,da;
register ULONG n;
APTR temp;
	
	FUNC
	if(P0->y < P1->y)
		{E=Ctx->edge1;}
	else
		{SWAP(P0,P1); E=Ctx->edge2;}

	dy= ((P1->y>>16) - (P0->y>>16) + 1);
	if(dy<1)
		return;	
	
/* compute linear distance(delta) for each "channels" among y */	
	x=P0->x; dx=(P1->x>>16) - (P0->x>>16); dx=(dx<<16)/dy;	
	z=P0->z; dz=(P1->z>>16) - (P0->z>>16); dz=(dz<<16)/dy;	
	
	u=P0->u; du=(P1->u>>16) - (P0->u>>16); du=(du<<16)/dy;	
	v=P0->v; dv=(P1->v>>16) - (P0->v>>16); dv=(dv<<16)/dy;	
	w=P0->w; dw=(P1->w>>16) - (P0->w>>16); dw=(dw<<16)/dy;	
	
	r=P0->r; dr=(P1->r>>16) - (P0->r>>16); dr=(dr<<16)/dy;	
	g=P0->g; dg=(P1->g>>16) - (P0->g>>16); dg=(dg<<16)/dy;	
	b=P0->b; db=(P1->b>>16) - (P0->b>>16); db=(db<<16)/dy;	
	a=P0->a; da=(P1->a>>16) - (P0->a>>16); da=(da<<16)/dy;	

/* for edge height */	
	y=P0->y>>16;
	E=&E[y];
	NLOOP(dy)
	{
	/* next pixel: new values for x y but no more need the decimal parts for x y */	
	E[n].x=x>>16;	x=x+dx;
	E[n].y=y;		y=y+1;
		
	/* next pixel: new values for each "channels" */	
	E[n].z=z;		z=z+dz;
		
	E[n].u=u;		u=u+du;
	E[n].v=v;		v=v+dv;
	E[n].w=w;		w=w+dw;
		
	E[n].r=r;		r=r+dr;
	E[n].g=g;		g=g+dg;
	E[n].b=b;		b=b+db;
	E[n].a=a;		a=a+da;
	}
	
/* securize extremities : make sure edge start/finish on original points */
	CopyFP(&E[0],P0);		
	E[0].x=E[0].x>>16;	/* no more need the decimal parts for x y */
	E[0].y=E[0].y>>16;				

	dy=dy-1;			/* last point at edge bottom */
	CopyFP(&E[dy],P1);		
	E[dy].x=E[dy].x>>16;	
	E[dy].y=E[dy].y>>16;	


}
/*==================================================================*/
void DrawPoly(struct Context3D *Ctx,ULONG Pnb)
{
register LONG ymin,ymax,ymed;
register struct FixPoint3D *P=Ctx->PolyFP;
register ULONG n;
ULONG NotClipped;
	
	FUNC
	CopyFP(&Ctx->PolyFP[Pnb],&Ctx->PolyFP[0]);	/* close poly */
	
	NotClipped=TestPoly(Ctx,Pnb);
VAR(NotClipped)
	if(NotClipped==-1) return;
	if(NotClipped== 0) Pnb=ClipPoly(Ctx,Pnb);

	ymin=ymax=P[0].y;
	NLOOP(Pnb)
	{
	if(P[n].y < ymin) ymin=P[n].y;
	if(ymax < P[n].y) ymax=P[n].y;
	}
	ymin=ymin>>16;
	ymax=ymax>>16;
	Ctx->PolyY=ymin;
	Ctx->PolyHigh=ymax-ymin+0;	

	if(Ctx->PolyHigh<2)
		return;

	NLOOP(Pnb)
		DrawEdge(Ctx,&P[n],&P[n+1]);

	ymed=(ymax+ymin)/2;

	if(Ctx->edge1[ymed].x < Ctx->edge2[ymed].x)
		FillPoly(Ctx,Ctx->edge1,Ctx->edge2);	
	else
		FillPoly(Ctx,Ctx->edge2,Ctx->edge1);	
}
/*==================================================================*/
void GetP(struct Context3D *Ctx,struct FixPoint3D *FP,ULONG i)
{
register struct Point3D *P;
register ULONG* PI;
struct RastPort *rp;
float maxint=65536.0;
	rp=C.window->RPort;	
	
	P=Ctx->P;
	PI=Ctx->PI;

	if(PI)
		i=PI[i];
	P=&P[i];	

//debug=TRUE;	
//PrintP(P);
//debug=FALSE;	
	
	FP->x=(floor(P->x)*maxint);		/* remove imprecision on pixel position */	
	FP->y=(floor(P->y)*maxint);	
	FP->z=(		(P->z)*maxint);	
	
	FP->u=(     (P->u)*maxint)*Ctx->T->w;	
	FP->v=(     (P->v)*maxint)*Ctx->T->h;	
	FP->w=(     (P->w)*maxint);	

	FP->r=( P->RGBA[0]*maxint);	
	FP->g=( P->RGBA[1]*maxint);	
	FP->b=( P->RGBA[2]*maxint);	
	FP->a=( P->RGBA[3]*maxint);	

}
/*==================================================================*/
void DrawTrianglesV(struct Context3D *Ctx)
{
register ULONG n;

	NLOOP(Ctx->TRInb)
	{
	GetP(Ctx,(&Ctx->PolyFP[0]),0+n*3);
	GetP(Ctx,(&Ctx->PolyFP[1]),1+n*3); 
	GetP(Ctx,(&Ctx->PolyFP[2]),2+n*3);
	DrawPoly(Ctx,3);
	}
	
}
/*==================================================================*/
void SetArrayV(struct Context3D *Ctx,struct Point3D  *P,ULONG *PI,ULONG PInb)
{
	Ctx->P		=P;
	Ctx->PI		=PI;
	Ctx->PInb	=PInb;	
	Ctx->TRInb	=PInb/3;	
}	
/*==================================================================*/
void BindTextureV(struct Context3D *Ctx,struct Texture3D *T)
{
	Ctx->T=T;
}
/*==========================================================================*/
struct Context3D *CreateContextV(struct Window  *window,UWORD w,UWORD h)
{
struct Context3D* Ctx;
ULONG size;
float maxint=65536.0;
	
	printf("Vampire3D:  1.01 build " __DATE__ " at " __TIME__ "\n");
	
	Ctx=(struct Context3D*)malloc(sizeof(struct Context3D)); 
	if(!Ctx)
		{printf("Cant create Context!\n");return(NULL);}
	memset(Ctx,0,sizeof(struct Context3D));
	Ctx->w=w;
	Ctx->h=h;		
		
	Ctx->xmin=(0)<<16;
	Ctx->ymin=(0)<<16;
	Ctx->zmin=(0)<<16;
	
	Ctx->xmax=(Ctx->w - 1)<<16;
	Ctx->ymax=(Ctx->h - 1)<<16;
	Ctx->zmax=(0.999*maxint);
		
	size=Ctx->w*Ctx->h*sizeof(ULONG);
	Ctx->pixels=(APTR)malloc(size);
	if(!Ctx->pixels)
		{printf("Cant create buffer!\n");return(NULL);}

	size=Ctx->w*Ctx->h*sizeof(ULONG);
	Ctx->zbuffer=(APTR)malloc(size);
	if(!Ctx->zbuffer)
		{printf("Cant create Zbuffer!\n");return(NULL);}

	Ctx->window=window;
		
	return(Ctx);	
}
/*==========================================================================*/
void DeleteContextV(struct Context3D* Ctx)
{
	if(Ctx->zbuffer)
		free(Ctx->zbuffer);
	free(Ctx);
}
/*==========================================================================*/		
void UpdateDisplay(struct Context3D* Ctx);	
/*==========================================================================*/		
void UpdateV(struct Context3D* Ctx,struct Window  *window)
{
ULONG size,n;
LONG *Zbuf32;
	
	UpdateDisplay(Ctx);
	
	size=Ctx->w*Ctx->h*sizeof(ULONG);
	memset(Ctx->pixels,0,size);

	size =Ctx->w*Ctx->h;
	Zbuf32=Ctx->zbuffer;
	NLOOP(size)
		Zbuf32[n]=Ctx->zmax;
}
/*==========================================================================*/